# list of all qospf nodes
RtModule/QOSPF set qospf_nodes_ ""

Simulator instproc configure-qospf-nodes {} {
    RtModule/QOSPF instvar qospf_nodes_
    #puts "in Simulator instproc configure-qospf-nodes"

    
    # 1. create qospf agents on all qospf nodes
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	$rtnode make-qospf-agent
    }

    # 1. set no. of nodes for use in MessageCenter

    if { [llength $qospf_nodes_] == 0 } {
	return
    }

    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set qagent [$rt set qospf_agent_]
    $qagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set qagentnode [$rtnode set qospf_agent_]
	$qagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	
	$qagentnode cmd initialize
    }
    
    
}

RtModule/QOSPF instproc register { node } {
    $self instvar classifier_ qospf_agent_ node_
    $class instvar qospf_nodes_

    #puts "in RtModule/QOSPF instproc register: node = $node, self = $self"

    $self set node_ $node

    #append node to qospf_nodes_
    lappend qospf_nodes_ $node
     
    #$self set classifier_ [$node entry]

    #$self set qospf_agent_ [new Agent/QOSPF $node]

    $node unreg-port-notify $self

    $self attach-node $node

    #debug 1


    
    #$node attach $qospf_agent_

}


RtModule/QOSPF instproc make-qospf-agent {} {
    $self instvar qospf_agent_ node_
    $self set qospf_agent_ [new Agent/QOSPF]
    #puts $node_
    $node_ attach $qospf_agent_
}


RtModule/QOSPF instproc intf-changed {} {
    $self instvar qospf_agent_
    #puts "in RtModule/QOSPF instproc intf-changed"
    $qospf_agent_ intf-changed
}

RtModule/QOSPF instproc get-explicit-route {dest bw} {
    $self instvar qospf_agent_
    #puts "in RtModule/QOSPF instproc get-explicit-route: dest = $dest, bw = $bw"
    set eroute [$qospf_agent_ get-explicit-route $dest $bw]
    return $eroute
   
}

RtModule/QOSPF instproc bw-changed {} {
    $self instvar qospf_agent_
    #puts "in RtModule/QOSPF instproc bw-changed"
    $qospf_agent_ bw-changed
}
